// JavaScript Document

//----------------------------- 文件下载 -------------------------------------------

	//判断文件是否存在
	function checkImage(filename,fileUrl,isLoad,isLocalSave,localName){
	   
	  window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
		  
			//console.log('打开的文件系统: ' + fs.name);
			
			createDir(fs.root,LocalPath.split('/'),false, filename, false,fileUrl,isLoad,isLocalSave,localName);
			
	  })
	}
	
	//加载图片
	function loadImage(filename,fileUrl,isLocalSave,localName){
	   
	  window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
		  
		  	createDir(fs.root,LocalPath.split('/'),true, filename, true,fileUrl,true,isLocalSave,localName);

	  }, onErrorLoadFs);
	}
	
	// fileTransfer plugin
	function downLoadImg(filePath,fileUrl,isLocalSave,localName) {
	   // 初始化FileTransfer对象
	   var fileTransfer = new FileTransfer();
	   // 服务器下载地址
	   var uri = encodeURI(fileUrl);
	   // 调用download方法
	   fileTransfer.download(
		   uri,         //uri网络下载路径
		   filePath,      //url本地存储路径
		   function(entry) {
			   console.log("download complete: " + entry.toURL());
			  
			    //alert('已保存到系统相册');
				//显示图片
				//displayImageByFileURL(fileURL);
				
				if(isLocalSave){
					//本地存储记录;fileUrl远程地址历史记录；remoteUrl当前远程地址
					$.LS.set(localName, "{\"filePath\":\""+filePath+"\",\"fileUrl\":\""+fileUrl+"\",\"remoteUrl\":\""+fileUrl+"\"}");
					
					//alert($.LS.get(localName));
				}
					  
		   },
		   function(error) {
			   
			   console.log("download error source " + error.source);
			   console.log("download error target " + error.target);
			   console.log("upload error code" + error.code);
				
		   }
	   );
	}
	
	//访问/创建文件夹
	//rootDir:当前文件夹路径；folders：文件夹目录序列；isfoldercreat:是否创建文件夹;
	//filename：文件名；isfilecreat：是否创建文件；fileUrl：文件远程访问地址url;isLoad:不存在时是否下载
	//isLocalSave：是否本地存储；localName：本地文件名称
	function createDir(rootDir,folders,isfoldercreat,filename,isfilecreat,fileUrl,isLoad,isLocalSave,localName) {
		
	  rootDir.getDirectory(folders[0], {create:isfoldercreat}, function(dirEntry) {
		  
		if (folders.length) {
		  
			//console.log("文件夹：" + folders.slice(1));
		  
			if(folders.slice(1)!=""){
				
				createDir(dirEntry, folders.slice(1),isfoldercreat,filename,isfilecreat,fileUrl,isLoad,isLocalSave,localName);
				
			}else{
				
				//console.log("检测文件：" + filename);
				
				dirEntry.getFile(filename, { create: isfilecreat, exclusive: false },function (fileEntry) {
					
					if(isfilecreat){
						downLoadImg(fileEntry.nativeURL,fileUrl,isLocalSave,localName);
					}else{
						//console.log("文件存在!");
					}
					
				},function(){
					if(isfilecreat){
						loadImage(filename,fileUrl,isLocalSave,localName);
					}else{
						
						if(isLoad){
							
							loadImage(filename,fileUrl,isLocalSave,localName);
							
						}else{
						
							//console.log("文件不存在!");
							
							//清空缓存
							if (typeof($.LS.get(localName)) != "undefined"){
								$.LS.remove(localName);
							}
						
						}
					}
					
				});
			}
		  
		}else{
			
		}
	  }, errorHandler);
	};
	//调用一：创建文件
	//createDir(fs.root, 'Documents/Images/'.split('/'),false,"loginbgimg.png",false,"http://xxx.com/loginbgimg.png",true,"loginbgimg");
	//调用一：不创建文件
	//createDir(fs.root, 'Documents/Images/'.split('/'),true,"loginbgimg.png",true,"http://xxx.com/loginbgimg.png",true,"loginbgimg");
	
	//文件访问失败
	function  errorHandler(error,filename,fileUrl,isLoad,isLocalSave,localName){
		
		//console.log("文件夹不存在");
		
		if(isLoad){
		
			//清空缓存
			if (typeof($.LS.get(localName)) != "undefined"){
				$.LS.remove(localName);
			}
			
			//下载文件
			loadImage(filename,fileUrl,isLocalSave,localName);
		}
	}
	
	//文件夹创建失败回调
	function onErrorCreatDir(error){
	  console.log("文件夹创建失败！")
	}
	
	//文件创建失败回调
	function onErrorCreateFile(error){
		console.log("文件不存在！")
	}

	//FileSystem加载失败回调
	function onErrorLoadFs(error){
	  console.log("文件系统加载失败！")
	}
	

	
//---------------------------------------------------- 文件拷贝 -------------------------------------------

	//判断原始文件是否存在
	function copyFileCheck(filename,filefrom,fileNewName,fileto,isCover,isLocalSave,localName){
	   
	  window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
		  
			console.log('打开的文件系统: ' + fs.name);
			
			//copyFile(fs.root,LocalPath.split('/'),false, filename, false,fileto,fileNewName,isLoad,isLocalSave,localName);
			copyFileFrom(fs.root,filefrom.split('/'),false, filename, false,fileNewName,fileto,isCover,isLocalSave,localName);
			
	  })
	}
	
	//判断文件是否存在
	function copyFileToCheck(filename,filefrom,fileNewName,fileto,isCover,isLocalSave,localName,fileEntry){
	   
	  window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
		  
			console.log('打开的文件系统: ' + fs.name);
			
			//copyFile(fs.root,LocalPath.split('/'),false, filename, false,fileto,fileNewName,isLoad,isLocalSave,localName);
			copyFileTo(fs.root,fileto.split('/'),false, filename, false,fileNewName,fileto,isCover,isLocalSave,localName,fileEntry);
			
	  })
	}
	
	//访问/创建文件夹
	//rootDir:当前文件夹路径；folders：文件夹目录序列；isfoldercreat:是否创建文件夹;
	//filename：文件名；isfilecreat：是否创建文件；fileNewName：新文件名，为空时默认原始文件名；fileto：拷贝路径;isCover:文件存在时是否覆盖
	//isLocalSave：是否本地存储；localName：本地文件名称
	function copyFileFrom(rootDir,folders,isfoldercreat,filename,isfilecreat,fileNewName,fileto,isCover,isLocalSave,localName) {
		
	  rootDir.getDirectory(folders[0], {create:isfoldercreat}, function(dirEntry) {
		  
		if (folders.length) {
		  
			//console.log("文件夹：" + folders.slice(1));
		  
			if(folders.slice(1)!=""){
				
				copyFileFrom(dirEntry, folders.slice(1),isfoldercreat,filename,isfilecreat,fileNewName,fileto,isCover,isLocalSave,localName);
				
			}else{
				
				//console.log("检测文件：" + filename);
				
				dirEntry.getFile(filename, { create: isfilecreat, exclusive: false },function (fileEntry) {
					
					console.log("文件存在!");
					
					//copyFileTo(fs.root, fileto.split('/'),isfoldercreat,filename,isfilecreat,fileNewName,fileto,isCover,isLocalSave,localName,fileEntry);
					
					copyFileToCheck(filename,fileto,fileNewName,fileto,isCover,isLocalSave,localName,fileEntry)

					
				},function(){
					console.log("文件不存在!");
				});
			}
		  
		}else{
			//console.log("文件夹不存在!");
		}
	  }, errorHandler);
	};
	
	//访问/创建文件夹
	//rootDir:当前文件夹路径；folders：文件夹目录序列；isfoldercreat:是否创建文件夹;
	//filename：文件名；isfilecreat：是否创建文件；fileNewName：新文件名，为空时默认原始文件名；fileto：拷贝路径;isCover:文件存在时是否覆盖
	//isLocalSave：是否本地存储；localName：本地文件名称,fileEntry:源文件路径
	function copyFileTo(rootDir,folders,isfoldercreat,filename,isfilecreat,fileNewName,fileto,isCover,isLocalSave,localName,fileEntry) {
		
	  rootDir.getDirectory(folders[0], {create:isfoldercreat}, function(dirEntry) {
		  
		if (folders.length) {
		  
			console.log("文件夹：" + folders.slice(1));
		  
			if(folders.slice(1)!=""){
				
				copyFileTo(dirEntry, folders.slice(1),isfoldercreat,filename,isfilecreat,fileNewName,fileto,isCover,isLocalSave,localName,fileEntry);
				
			}else{
				
				//console.log("检测文件：" + filename);
				
				dirEntry.getFile(filename, { create: isfilecreat, exclusive: false },function (fileEntryTo) {
					
					console.log("文件存在!");
					
					//entry.copyTo( parent, newName, succesCB, errorCB );
					fileEntry.copyTo(dirEntry, fileNewName, onSuccesCopy, onErrorCopy );

					//parent: ( DirectoryEntry ) 必选 要拷贝到的目标目录
					//newName: ( DOMString ) 可选 拷贝后的目录名称，默认为原始目录名称
					//succesCB: ( EntrySuccessCallback ) 可选 拷贝目录成功的回调函数
					//回调函数中的参数保存新的目录对象。
					//errorCB: ( FileErrorCallback ) 可选 拷贝目录失败的回调函数

					
				},function(){
					console.log("文件不存在!");
					
					fileEntry.copyTo(dirEntry, fileNewName, onSuccesCopy, onErrorCopy );
				});
			}
		  
		}else{
			console.log("文件夹不存在!");
		}
	  }, errorHandler);
	};
	
	//File复制成功回调
	function onSuccesCopy(){
	  console.log("文件复制成功！")
	}
	
	//File复制失败回调
	function onErrorCopy(error){
	  console.log("文件复制失败！")
	}
	
//---------------------------------------------------- 文件拷贝Url -------------------------------------------
	
	//filefrom：原始文件；fileto：复制到的路径,filename:新文件名
	function copyFile(filefrom,fileto,filename){
		//window.resolveLocalFileSystemURL('file:///storage/sdcard1/相机/IMG_20181117_125330.jpg',function(fileEntry) {
		window.resolveLocalFileSystemURL(filefrom,function(fileEntry) {
	 
			//window.resolveLocalFileSystemURL('cdvfile://localhost/persistent/Cobaba/Images',function(dirEntry) {
			window.resolveLocalFileSystemURL(fileto,function(dirEntry) {
			
				//fileEntry.copyTo(dirEntry, "icon.png", successCallback, errorCallback);
				fileEntry.copyTo(dirEntry, filename, successCallback, errorCallback);
			
			}, function(error){console.log("文件夹访问失败！")});
	 
		},function(error){console.log("文件访问失败！")});
	}
	 
	//文件复制成功
	function  successCallback() {
	 console.log("文件复制成功！")
	}
	 
	//文件复制失败
	function  errorCallback() {
	 console.log("文件复制失败！")
	}