// JavaScript Document

//极光推送的初始化

var onDeviceReady = function() {
  document.addEventListener("jpush.receiveRegistrationId", function (event) {
		//alert("receiveRegistrationId" + JSON.stringify(event));
		//$("#registrationId").html(event.registrationId);
	}, false)
  initiateUI();
};

var getRegistrationID = function() {
  window.JPush.getRegistrationID(onGetRegistrationID);
};

//获取RegistrationID 绑定用户
var onGetRegistrationID = function(data) {
  try {
	//console.log("JPushPlugin:registrationID is " + data);
	
	if (data.length == 0) {
	  var t1 = window.setTimeout(getRegistrationID, 1000);
	}else{
		
		//获取数据
		if (typeof($.LS.get('userinfo')) != "undefined"){
			
			//当前用户信息/转化为json对象
			var user=JSON.parse($.LS.get('userinfo'));
			
			if(user.registrationid=="" || user.registrationid!=data){
				
				var sendData = new Object();
				sendData["token"]=$.LS.get('token');
				sendData['timestamp']=(new Date()).getTime();
				sendData['reid']=data;
				
				// 加载数据
				var ajaxUrl=ApiDomain+"/user/jpush/";
				
				$.ajax({
					url: ajaxUrl,
					timeout : 20000, //超时时间设置，单位毫秒
					type: 'post',
					data: sendData,
					success:function(resultdata){
						
						//定义用户信息
						user.registrationid=data;
						$.LS.set('userinfo',JSON.stringify(user));
				
//						//提示
//						  layer.open({
//							content: '提交成功！'
//							,skin: 'msg'
//							,time: 2 //2秒后自动关闭
//						  });
					},
					error:function(){
					
//						//提示
//						  layer.open({
//							content: '提交失败！'
//							,skin: 'msg'
//							,time: 2 //2秒后自动关闭
//						  });
					}
				});
				
			}
			
		}
		
		if(typeof($.LS.get('token'))!="undefined"){
			page['token'] = $.LS.get('token');
		}
		
		page['timestamp']=(new Date()).getTime();
		
		if(typeof($.LS.get('token'))!="undefined"){
			page['token'] = $.LS.get('token');
		}
		
	}
	//$("#registrationId").html(data);
	
  } catch (exception) {
	console.log(exception);
  }
};

var onTagsWithAlias = function(event) {
  try {
	console.log("onTagsWithAlias");
	var result = "result code:" + event.resultCode + " ";
	result += "tags:" + event.tags + " ";
	result += "alias:" + event.alias + " ";
	//$("#tagAliasResult").html(result);
  } catch (exception) {
	console.log(exception)
  }
};

var onOpenNotification = function(event) {
	
  var msg_title='';
  var msg_url='';
	
  try {
	var alertContent;
	if (device.platform == "Android") {
	  alertContent = event.alert;
	  //alert(JSON.stringify(event.extras));
	  
	  //判断是否存在附加参数title
	  if(event.extras.hasOwnProperty("msg_title")){
		  	msg_title=event.extras.msg_title
	  }
	  
	  //判断是否存在附加参数url
	  if(event.extras.hasOwnProperty("msg_url")){
		  	msg_url=event.extras.msg_url
	  }
	  
	} else {
	  alertContent = event.aps.alert;
	  
	  
	  //判断是否存在附加参数title
	  if(event.hasOwnProperty("msg_title")){
		  	msg_title=event.msg_title
	  }
	  
	  //判断是否存在附加参数url
	  if(event.hasOwnProperty("msg_url")){
		  	msg_url=event.msg_url
	  }
	}
	//alert("open Notification:" + alertContent);
	
	if(msg_url!=''){
		
		var openerUrl="ExternalUrl.html?url="+msg_url;
		
		if(msg_title!=''){
			openerUrl="ExternalUrl.html?title="+msg_title+"&url="+msg_url;
		}
		
		var openerAnimation="pt-page-moveToLeft";
		PageLoad(openerAnimation,openerUrl);
	
	}else{	
	
		layer.open({
		className: 'notify', //这样你就可以在css里面控制该弹层的风格了
		content:'<div class="close"><i class="fa fa-times-circle-o" aria-hidden="true"></i></div><div class="notify_content">'+alertContent+'</div>'
	})
	
		$(".fa-times-circle-o").on("click",function(){
			layer.closeAll();
		})
		
	}
	
  } catch (exception) {
	console.log("JPushPlugin:onOpenNotification" + exception);
  }
};

var onReceiveNotification = function(event) {
  try {
	var alertContent;
	if (device.platform == "Android") {
	  alertContent = event.alert;
	} else {
	  alertContent = event.aps.alert;
	}
	//$("#notificationResult").html(alertContent);
	
//	//提示
//	  layer.open({
//		content: alertContent
//		,btn: '关闭'
//	  });
	  
  } catch (exception) {
	console.log(exception)
  }
};

var onReceiveMessage = function(event) {
  try {
	var message;
	if (device.platform == "Android") {
	  message = event.message;
	} else {
	  message = event.content;
	}
	//$("#messageResult").html(message);
	
//	//提示
//	  layer.open({
//		content: message
//		,btn: '关闭'
//	  });
	  
  } catch (exception) {
	console.log("JPushPlugin:onReceiveMessage-->" + exception);
  }
};

var initiateUI = function() {
  try {
	window.JPush.init();
	window.JPush.setDebugMode(true);
	window.setTimeout(getRegistrationID, 1000);
	if (device.platform != "Android") {
	  window.JPush.setApplicationIconBadgeNumber(0);
	}
  } catch (exception) {
	console.log(exception);
  }
};

document.addEventListener("deviceready", onDeviceReady, false);
document.addEventListener("jpush.openNotification", onOpenNotification, false);
document.addEventListener("jpush.receiveNotification", onReceiveNotification, false);
document.addEventListener("jpush.receiveMessage", onReceiveMessage, false);